// 002 u_dbx4_04_pooling_win32
// 18 sep 2007

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_dbx4_04_pooling_win32;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, WideStrings, StdCtrls, ExtCtrls, ComCtrls, FMTBcd, Grids, DBGrids,
  DB, DBClient, Provider, SqlExpr;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Splitter1: TSplitter;
    PageControl1: TPageControl;
    log_: TTabSheet;
    Memo1: TMemo;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    connection_: TTabSheet;
    PageControl2: TPageControl;
    ini_: TTabSheet;
    tr_log_: TTabSheet;
    trace_log_memo_: TMemo;
    exec_: TTabSheet;
    Panel3: TPanel;
    disconnect_: TButton;
    display_trace_: TButton;
    trace_connect_panel_: TPanel;
    dbExpress_: TTabSheet;
    SQLConnection1: TSQLConnection;
    SQLDataSet1: TSQLDataSet;
    DataSetProvider1: TDataSetProvider;
    ClientDataSet1: TClientDataSet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    connection_memo_: TMemo;
    Panel7: TPanel;
    save_connection_: TButton;
    connection_name_edit_: TEdit;
    Panel5: TPanel;
    display_connection_names_: TButton;
    sorted_: TCheckBox;
    connection_listbox_: TListBox;
    connect_panel_: TPanel;
    add_pool_: TButton;
    log_file_name_edit_: TEdit;
    Panel4: TPanel;
    connect_: TButton;
    delete_: TButton;
    ini__: TTabSheet;
    Panel6: TPanel;
    ini_memo_: TMemo;
    load_ini_: TButton;
    save_ini_: TButton;
    do_save_ini_: TCheckBox;
    clear_trace_: TButton;
    Panel8: TPanel;
    trace_: TRadioButton;
    pool_: TRadioButton;
    pool_trace_: TRadioButton;
    iteration_edit_: TEdit;
    connect_disconnect_: TButton;
    fill_connection_list_: TButton;
    Panel9: TPanel;
    client_dataset_open_: TButton;
    add_pool_trace_: TButton;
    connect__: TButton;
    no_pool_no_trace_: TRadioButton;
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure connect__Click(Sender: TObject);
    procedure dbx_select_table_Click(Sender: TObject);
    procedure disconnect_Click(Sender: TObject);
    procedure display_connection_names_Click(Sender: TObject);
    procedure connection_listbox_Click(Sender: TObject);
    procedure display_trace_Click(Sender: TObject);
    procedure create_table__Click(Sender: TObject);
    procedure connect_Click(Sender: TObject);
    procedure delete_Click(Sender: TObject);
    procedure save_connection_Click(Sender: TObject);
    procedure load_ini_Click(Sender: TObject);
    procedure save_ini_Click(Sender: TObject);
    procedure clear_trace_Click(Sender: TObject);
    procedure client_dataset_open_Click(Sender: TObject);
    procedure add_pool_Click(Sender: TObject);
    procedure connect_disconnect_Click(Sender: TObject);
    procedure fill_connection_list_Click(Sender: TObject);
    procedure add_pool_trace_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses  DbxCommon
      , DBByteBuffer, StrUtils

      , u_c_display
      , u_strings
      , u_c_dbx4_ini
      , u_c_dbx4

      ;

    {$R *.dfm}

  
    const k_connection_name= 'EMPLOYEE_7';
          // -- default when loads a key
          k_default_connectionr_name= 'EMPLOYEE_7';

          k_blackfish_connection_name= 'dbx_employee_jds';

    var g_connection_name: String= k_connection_name;
        g_connection_name_index: Integer= 0;
        g_c_dbx4_connections_ini: c_dbx4_connections_ini= Nil;

        g_c_dbx_connection: tDbxConnection= Nil;

    procedure set_panel_color(p_c_panel: tPanel; p_color: Integer);
      begin
        p_c_panel.Color:= p_color;
        Application.ProcessMessages;
      end; // set_panel_color

    function f_s_connection_name: String;
      var l_connection_name: String;
      begin
        Result:= g_connection_name;

        if Form1.pool_.Checked
          then begin
            if f_end_is_equal_to(g_connection_name, '_POOL')
              then
              else Result:= g_connection_name+ '_POOL';
            end;

        if Form1.trace_.Checked
          then
            if    f_end_is_equal_to(g_connection_name, '_TRACE')
                or
                  f_end_is_equal_to(g_connection_name, '_TRACE_W_FILE')
              then
              else begin
                  if Trim(Form1.log_file_name_edit_.Text)= ''
                    then Result:= g_connection_name+ '_TRACE'
                    else Result:= g_connection_name+ '_TRACE_W_FILE';

                end;

        if Form1.pool_trace_.Checked
          then begin
            if f_end_is_equal_to(g_connection_name, k_pool_suffix+ k_file_trace_suffix)
              then
              else begin
                  l_connection_name:= g_connection_name;
                  if Pos(k_trace_suffix, g_connection_name)> 0
                    then l_connection_name:= f_remove_end_if_end_is_equal_to(g_connection_name, k_trace_suffix)
                    else
                      if Pos(k_pool_suffix, g_connection_name)> 0
                        then l_connection_name:= f_remove_end_if_end_is_equal_to(g_connection_name, k_pool_suffix);

                  Result:= l_connection_name+ k_pool_suffix+ k_file_trace_suffix;
                end;
            end;

        if Form1.connection_listbox_.Items.IndexOf(Result)< 0
          then display_bug_halt('no_trace_connection. Create one first');
      end; // f_s_connection_name

    function f_w_connection_name: WideString;
      begin
        Result:= f_w_connection_name;
      end; // f_w_connection_name

    function f_c_dbx_connection(p_connection_name: String): tDbxConnection;
      var l_c_dbx_connection_factory: TDBXConnectionFactory;
          l_c_dbx_connection_properties: TDBXProperties;
      begin
        with Form1 do
        begin
          l_c_dbx_connection_factory:= TDBXConnectionFactory.GetConnectionFactory;

          l_c_dbx_connection_properties:= l_c_dbx_connection_factory.GetConnectionProperties(p_connection_name);
          Result:= Nil;

          set_panel_color(connect_panel_, clRed);
          set_panel_color(trace_connect_panel_, clRed);

          Result:= l_c_dbx_connection_factory.GetConnection(l_c_dbx_connection_properties);
          set_panel_color(trace_connect_panel_, clLime);
          set_panel_color(connect_panel_, clLime);
        end; // with Form1
      end; // do_connect

    procedure refresh_connection_list;
      begin
        with Form1 do
        begin
          refresh_connection_factory;
          display_connection_names_Click(nil);
        end; // with Form1
      end; // refresh_connection_list

    // -- form1 methods

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        display_connection_names_Click(Nil);
        with connection_listbox_ do
        begin
          ItemIndex:= Items.IndexOf(g_connection_name);
          if ItemIndex>= 0
            then connection_listbox_Click(Nil);
        end;
        Caption:= g_connection_name;

        g_c_dbx4_connections_ini:= c_dbx4_connections_ini.create_dbx4_connections_ini('');
        g_c_dbx4_connections_ini.m_c_readonly_connection_name_list.Add(k_default_connectionr_name);

        log_file_name_edit_.Text:= k_default_trace_file_name;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    // -- connection handling

    procedure TForm1.load_ini_Click(Sender: TObject);
      begin
        ini_memo_.Lines.LoadFromFile(f_connections_ini_file_name);
      end; // load_ini_Click

    procedure TForm1.save_ini_Click(Sender: TObject);
      begin
        if do_save_ini_.Checked
          then ini_memo_.Lines.SaveToFile(f_connections_ini_file_name);
      end; // save_ini_Click

    procedure TForm1.display_connection_names_Click(Sender: TObject);
      begin
        PageControl1.ActivePage:= connection_;

        connection_listbox_.Sorted:= sorted_.Checked;

(*
        // -- since appends, clear tStrings before
        connection_listbox_.Items.Clear;
        // -- fetch the singleton and retrieve the names
        TDBXConnectionFactory.GetConnectionFactory.GetConnectionItems(connection_listbox_.Items);
*)
        get_connection_name_list(connection_listbox_.Items);
        // display(connection_listbox_.Items.Text);
      end; // display_connection_names_Click

    procedure TForm1.connection_listbox_Click(Sender: TObject);
      begin
        with connection_listbox_ do
          if ItemIndex< 0
            then Exit
            else g_connection_name:= Items[ItemIndex];
        Caption:= g_connection_name;

        // -- display the connection properties
        get_connection_parameter_list(g_connection_name, connection_memo_.Lines);

        connection_name_edit_.Text:= g_connection_name;
      end; // connection_listbox_Click

    procedure TForm1.connect_Click(Sender: TObject);
      var l_selected_connection_name: String;
          l_c_dbx_connection: tDbxConnection;
      begin
        display('> connect');
        PageControl1.ActivePage:= connection_;

        with connection_listbox_ do
          l_selected_connection_name:= Items[ItemIndex];

        Try
          l_c_dbx_connection:= f_c_dbx_connection(l_selected_connection_name);
        finally
          l_c_dbx_connection.Free;
        end;

        display('< connect');
      end; // connect_Click

    procedure TForm1.add_pool_Click(Sender: TObject);
        // -- brutally add the delegate line to a copy
      begin
        g_c_dbx4_connections_ini.append_pool_delegate_to(g_connection_name);

        refresh_connection_list;
        with connection_listbox_ do
          ItemIndex:= Items.IndexOf(k_default_connectionr_name);
        connection_listbox_Click(Nil);
      end; // add_pool_Click

    procedure TForm1.add_pool_trace_Click(Sender: TObject);
      begin
        // -- add the intermediate connection
        g_c_dbx4_connections_ini.append_dbx4_pool_file_trace_connection(
            k_file_delegation, k_pool_trace_delegation);

        // -- add the database delegate driver
        // -- EMPLOYEE_7 --> EMPLOEYEE_POOL_7_TRACE_W_FILE
        g_c_dbx4_connections_ini.append_pool_file_trace_delegate_to(g_connection_name);

        refresh_connection_list;
        with connection_listbox_ do
          ItemIndex:= Items.IndexOf(k_default_connectionr_name);
        connection_listbox_Click(Nil);
      end; // add_pool_trace_Click

    procedure TForm1.delete_Click(Sender: TObject);
      var l_selected_connection_name: String;
          l_c_dbx_connection_factory: TDBXConnectionFactory;
      begin
        set_panel_color(connect_panel_, clRed);
        PageControl1.ActivePage:= connection_;

        with connection_listbox_ do
          l_selected_connection_name:= Items[ItemIndex];

        display_line;
        display('> delete_connection '+ l_selected_connection_name);

        if g_c_dbx4_connections_ini.f_delete_section(l_selected_connection_name)
          then begin
              refresh_connection_list;
              with connection_listbox_ do
                ItemIndex:= Items.IndexOf(k_default_connectionr_name);
              connection_listbox_Click(Nil);

              set_panel_color(connect_panel_, clLime);
            end;
        display('< delete_connection');
      end; // delete_Click

    procedure TForm1.disconnect_Click(Sender: TObject);
      begin
        FreeAndNil(g_c_dbx_connection);
        SqlConnection1.Close;
      end; // disconnect_Click

    procedure TForm1.save_connection_Click(Sender: TObject);
      var l_error_index: Integer;
          l_key_index: Integer;
          l_selected_connection_name, l_edit_connection_name: String;
      begin
        l_error_index:= f_is_valid_parameter_list(connection_memo_.Lines);
        if l_error_index>= 0
          then begin
              display_bug_stop('not_key=value '+ connection_memo_.Lines[l_error_index]);
              Exit;
            end;

        // -- get the selected connection name
        with connection_listbox_ do
          l_selected_connection_name:= Items[ItemIndex];
        l_edit_connection_name:= connection_name_edit_.Text;
        Caption:= l_selected_connection_name;

        with g_c_dbx4_connections_ini do
          if f_update_or_append_section(l_edit_connection_name, connection_memo_.Lines)
            then begin
                refresh_connection_list;
                with connection_listbox_ do
                  ItemIndex:= Items.IndexOf(l_edit_connection_name);
                // -- update the current connection
                connection_listbox_Click(Nil);
              end;
      end; // save_connection_Click

    // -- connect with trace

    procedure TForm1.connect__Click(Sender: TObject);
      begin
        PageControl1.ActivePage:= log_;

        display_line;
        display('> connect__Click '+ f_s_connection_name);

        g_c_dbx_connection.Free;
        g_c_dbx_connection:= f_c_dbx_connection(f_s_connection_name);

        display('< connect__Click');
      end; // connect_Click

    // -- pooling benchmarks

    procedure TForm1.connect_disconnect_Click(Sender: TObject);
        // -- benchmark: open and close connections
      var l_iteration_max, l_iteration: Integer;
          l_save_start_tick: Integer;
          l_connection_name: String;
      begin
        PageControl1.ActivePage:= log_;
        l_iteration_max:= StrToInt(iteration_edit_.Text);
        l_save_start_tick:= GetTickCount;
        l_connection_name:= f_s_connection_name;

        for l_iteration:= 0 to l_iteration_max - 1 do
          with TDBXConnectionFactory
              .GetConnectionFactory
              .GetConnection(l_connection_name, '', '') do
            Free;

        display(l_connection_name+ ' '+ IntToStr(GetTickCount - l_save_start_tick));
      end; // connect_disconnect_Click

    procedure TForm1.fill_connection_list_Click(Sender: TObject);
        // -- benchmark: open a connection and keep it in memory
        // --   cannot do with InterBase, since hits connection max
        // --   and for Blackfish it is 20 :
      var l_connection_name: String;
          l_c_connection_list: tList;
          l_iteration_max, l_iteration: Integer;
          l_save_start_tick: Integer;
      begin
(*
        if g_connection_name<> k_blackfish_connection_name
          then begin
            with connection_listbox_ do
            begin
              ItemIndex:= Items.IndexOf(k_blackfish_connection_name);
              if ItemIndex< 0
                then display_bug_halt('add a '+ k_blackfish_connection_name);
              connection_listbox_Click(Nil);
            end;
*)
        PageControl1.ActivePage:= log_;
        l_connection_name:= f_s_connection_name;

        l_iteration_max:= StrToInt(iteration_edit_.Text);
        if (Pos('ib', LowerCase(l_connection_name))>= 0)
            and (l_iteration_max> 4)
          then l_iteration_max:= 4
          else
            if (Pos('jds', LowerCase(l_connection_name))>= 0)
                and (l_iteration_max> 20)
              then l_iteration_max:= 20;

        iteration_edit_.Text:= IntToStr(l_iteration_max);
              
        l_c_connection_list:= tList.Create;

        l_save_start_tick:= GetTickCount;

        for l_iteration:= 0 to l_iteration_max - 1 do
          l_c_connection_list.Add(TDBXConnectionFactory
              .GetConnectionFactory
              .GetConnection(l_connection_name, '', ''));

        display(l_connection_name+ ' '+ IntToStr(GetTickCount - l_save_start_tick));

        for l_iteration:= 0 to l_iteration_max - 1 do
          TDBXConnection(l_c_connection_list[l_iteration]).Free;
      end; // fill_connection_list_Click

    // -- some data access


    procedure TForm1.dbx_select_table_Click(Sender: TObject);
      begin
        display_line;
        display('> open_table');

        read_and_display_table(g_c_dbx_connection,
            'SELECT * FROM country', Memo1.Lines);

        display('< open_table');
      end; // dbx_select_table_Click

    procedure TForm1.create_table__Click(Sender: TObject);
      var l_create_table: String;
      begin
        l_create_table:=
             'CREATE TABLE training1'
          +  '  (training_id Integer, training_name CHAR(15))';
        execute_sql_statement(g_c_dbx_connection, l_create_table);
      end; // create_table__Click

    procedure TForm1.display_trace_Click(Sender: TObject);
        // -- the connection MUST be closed (shared access)
      begin
        if (g_c_dbx_connection<> Nil) or SqlConnection1.Connected
          then display_bug_stop('disconnect_first')
          else begin
              PageControl1.ActivePage:= tr_log_;
              trace_log_memo_.Lines.LoadFromFile(log_file_name_edit_.Text);
            end;
      end; // display_trace_Click

    procedure TForm1.clear_trace_Click(Sender: TObject);
      begin
        if g_c_dbx_connection<> Nil
          then display_bug_stop('disconnect_first')
          else begin
              PageControl1.ActivePage:= tr_log_;
              trace_log_memo_.Lines.Clear;
              trace_log_memo_.Lines.SaveToFile(log_file_name_edit_.Text);
            end;
      end; // clear_trace_Click

    // -- use DbExpress access components

    procedure TForm1.client_dataset_open_Click(Sender: TObject);
      begin
        PageControl1.ActivePage:= dbExpress_;

        with SqlConnection1 do
        begin
          Close;

          ConnectionName:= f_s_connection_name;
        end; // with SqlConnection1
        SqlDataSet1.Close;
        ClientDataSet1.Close;

        ClientDataset1.Open;
      end; // client_dataset_open_Click

end.

