// 002 u_c_dbx4
// 17 sep 2007

// -- (C) Felix John COLIBRI 2007
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_c_dbx4;
  interface
    uses Classes, DbxCommon
       , u_c_basic_object
       ;

    procedure read_and_display_table(p_c_dbx_connection: tDbxConnection;
        p_select_request: String;
        p_c_strings: tStrings);
    procedure execute_sql_statement(p_c_dbx_connection: tDbxConnection;
        p_sql_request: WideString);

  implementation
    uses SysUtils, u_c_display;

    procedure read_and_display_table(p_c_dbx_connection: tDbxConnection;
        p_select_request: String;
        p_c_strings: tStrings);
      var l_c_dbx_transaction: TDBXTransaction;
          l_c_dbx_command: TDBXCommand;
          l_c_dbx_reader: TDBXReader;

          l_row_string: String;
          l_column_index: Integer;
      begin
        display('> read_table '+ p_select_request);
        l_c_dbx_transaction:= p_c_dbx_connection.BeginTransaction();
        l_c_dbx_command:= p_c_dbx_connection.CreateCommand;
        l_c_dbx_reader:= Nil;

        try
          l_c_dbx_command.Text:= p_select_request;
          l_c_dbx_reader:= l_c_dbx_command.ExecuteQuery;

          // -- display in the Memo
          while l_c_dbx_reader.Next do
          begin
            l_row_string:= '';

            for l_column_index:= 0 to l_c_dbx_reader.ColumnCount - 1 do
            begin
              if l_row_string<> ''
                then l_row_string:= l_row_string+ ' | ';
              l_row_string:= l_row_string+ l_c_dbx_reader.Value[l_column_index].GetAnsiString; //   .GetString;
            end;
            display(l_row_string);
          end;

        finally
          p_c_dbx_connection.CommitFreeAndNil(l_c_dbx_transaction);
          l_c_dbx_command.Free;
          l_c_dbx_reader.Free;
        end;
        display('< read_table');
      end; // read_and_dipslay_table

    procedure execute_sql_statement(p_c_dbx_connection: tDbxConnection;
        p_sql_request: WideString);
      var l_c_dbx_database_metadata: TDBXDatabaseMetaData;
          l_c_dbx_transaction: TDBXTransaction;
          l_c_dbx_command: TDBXCommand;
      begin
        display(p_sql_request);

        if p_c_dbx_connection.IsOpen
          then
            begin
              display('is_open');
              l_c_dbx_command:= Nil;
              try
                l_c_dbx_database_metadata:= p_c_dbx_connection.DatabaseMetaData;
                if l_c_dbx_database_metadata.SupportsTransactions
                  then l_c_dbx_transaction:= p_c_dbx_connection.BeginTransaction();

                try
                  l_c_dbx_command:= p_c_dbx_connection.CreateCommand;
                  l_c_dbx_command.Text:= p_sql_request;
                  l_c_dbx_command.ExecuteQuery;
                  if l_c_dbx_database_metadata.SupportsTransactions
                    then p_c_dbx_connection.CommitFreeAndNil(l_c_dbx_transaction);
                  display('ok_executed');
                finally
                  if l_c_dbx_database_metadata.SupportsTransactions
                    then p_c_dbx_connection.RollbackIncompleteFreeAndNil(l_c_dbx_transaction);

                  if Assigned(l_c_dbx_command)
                    then l_c_dbx_command.Free;
                end;
              except
                on E: Exception do
                  display_bug_stop('exception '+ e.Message);
              end; // try except
            end // IsOpen
          else display_bug_stop('not_open')  ;
      end; // execute_sql_statement

    begin // u_c_dbx_connection
    end. // u_c_dbx_connection


